﻿using System;

using System.Collections;

using System.Collections.Generic;
using System.Text;

// メニュー.プロジェクト.参照の追加よりsystem.xml.dllを追加
using System.Xml;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace ccc4
{

    // BoundingBox を持つオブジェクトを配置
    // cube,ビル(cubeにより作成される)

/*
 * cube配列,ビル配列を持つ
 * 配列の順に衝突判定を行う
 * 
 */    
    
    public class 地形
    {

        // .configにのみ保存
        // 音量
        public float musicVolume = 0f;

        // .configにのみ保存
        // ファイルダイアログ起動ディレクトリ 初期値:exe直下のxmlフォルダ
        public string InitialDirectory = "";

        // .configにのみ保存
        // 操作上下リバース 飛行モード ピッチ + カメラ上下反転 
        public bool b上下リバース = true;


        public ビル[] ビル;

        [System.Xml.Serialization.XmlIgnoreAttribute]
        public bool[] bビル表示; // BoundingFrustum判定 true:内 false:外

        // ビル詳細表示時には描画順序に注意

        // --------------------------------------
        public 地形()
        {
            this.ビル = new ビル[64];

            this.bビル表示 = new bool[this.ビル.Length];
        }



        float def_h = 4f;   // ビル1階分の高さ

        // --------------------------------------
        public void Initialize( GraphicsDeviceManager graphics, float 球半径 )
        {

            // ビル設定
            for (int i = 0; i < this.ビル.Length; i++)
            {
                this.ビル[i] = new ビル();

                // 上側の幅w、奥行きd, 下側の幅w、奥行きd, 高さh, 階数 を指定
                // １階分の高さ = 8
/*
                this.ビル[i].Initialize(graphics, true, 8, 8, 56, 56, ((i + 1) * def_h), i + 1);   // 標準(台形)
                this.ビル[i].Initialize(graphics, true, 16, 32, 16, 32, ((i + 1) * def_h), i + 1); // 方形
                this.ビル[i].Initialize(graphics, true,  1, 56, 56,  1, ((i + 1) * def_h), i + 1); // 4面体
                this.ビル[i].Initialize(graphics, true,  1, 1, 1, 1, 1, 1 ); // 幅、奥行き、高さ、階数:最小 
                this.ビル[i].Initialize(graphics, true, 56, 56, 1,1, ((i + 1) * def_h), i + 1);   // 逆台形
                this.ビル[i].Initialize(graphics, true, 8, 8, 56, 56, 1000, 1000);   // 台形 高さ最大
*/


/*
                this.ビル[i].Initialize(graphics, true,  8,  8, 56, 56, 8, 2);  // 標準(台形)
                this.ビル[i].Initialize(graphics, true, 16, 32, 16, 32, 1, 2);  // 方形
*/

/*
                // ビルの形:交互に
                if( 1 == i%2 )
                {
                    this.ビル[i].Initialize(graphics, true, 8, 8, 56, 56, 8, 2);  // 標準(台形)
                }
                else
                {
                    this.ビル[i].Initialize(graphics, true, 16, 32, 16, 32, 1, 2);  // 方形
                }
*/
                this.ビル[i].Initialize(graphics, true, 8, 8, 56, 56, ((i + 1) * def_h), i + 1);   // 標準(台形)

                this.ビル[i].pos = new Vector3(0, 球半径 - 1, 0); // ppp
                this.ビル[i].単位行列 = Matrix.Identity;

                this.bビル表示[i] = false;

                this.ビル[i].m_外壁テクスチャNo = 7;
                this.ビル[i].m_床テクスチャNo= 7;
            }

            // this.ビル[0].Initialize(graphics, true, 1, 1000, 1000, 1, 1000, 100); // 4面体ビル
            
            int ビルNo = 0;

            float 位置調整 = 16f;

            // A -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    // 224 = 64*3+32
                    this.ビル[ビルNo].直進_Q(  -224 + (i * 64) - 位置調整);
                    this.ビル[ビルNo].横移動_Q(-224 + (j * 64) - 位置調整);

                    ビルNo++;
                }
            }

            // B -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    // 224 = 64*3+32
                    this.ビル[ビルNo].直進_Q(    32 + (i * 64) + 位置調整);
                    this.ビル[ビルNo].横移動_Q(-224 + (j * 64) - 位置調整);

                    ビルNo++;
                }
            }

            // C -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    // 224 = 64*3+32
                    this.ビル[ビルNo].直進_Q( -224 + (i * 64) - 位置調整);
                    this.ビル[ビルNo].横移動_Q( 32 + (j * 64) + 位置調整);

                    ビルNo++;
                }
            }

            // D -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    this.ビル[ビルNo].直進_Q(   32 + (i * 64) + 位置調整 );
                    this.ビル[ビルNo].横移動_Q( 32 + (j * 64) + 位置調整 );

                    ビルNo++;
                }
            }

            // ビル床設定
            for (int i = 0; i < this.ビル.Length; i++)
            {
                this.ビル[i].床pos設定();   // 床のposと単位行列を再設定( 順序注意 ビルのposと行列設定後に設定 )
            }


            // --------------------------------------------------------------
            // 円周 ビルを球上に一列に並べる。
/*
            float len = (MathHelper.Pi * (球半径 * 2)) / this.ビル.Length;   // 移動距離
            for (int i = 0; i < this.ビル.Length; i++)
            {
                this.ビル[i].pos = new Vector3(0, 球半径 - 1, 0); // ppp
                this.ビル[i].単位行列 = Matrix.Identity;
                this.ビル[i].直進_Q(i * len);
                this.ビル[i].床pos設定();   // 床のposと単位行列を再設定( 順序注意 ビルのposと行列設定後に設定 )
            }
*/

            // ビルが重なっていないことを確認する。
        }




        
        
        // --------------------------------------
        // 分散パターン 作成
        public void Initialize2(GraphicsDeviceManager graphics, float 球半径)
        {

            // ビル設定
            for (int i = 0; i < this.ビル.Length; i++)
            {
                this.ビル[i] = new ビル();
            }

            int ビルNo = 0;

            // A -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    this.ビル[ビルNo].Initialize(graphics, true, 8, 8, 56, 56, 1, ビルNo + 1);   // 標準(台形)

                    this.ビル[ビルNo].pos = new Vector3(0, 球半径 - 1, 0); // ppp
                    this.ビル[ビルNo].単位行列 = Matrix.Identity;


                    this.ビル[ビルNo].m_外壁テクスチャNo = 1;
                    this.ビル[ビルNo].m_床テクスチャNo = 1;

                    float L = 0f;   // 球上の移動量 北極

                    this.ビル[ビルNo].直進_Q( -96 + (i * 64) + L );
                    this.ビル[ビルNo].横移動_Q(-96 + (j * 64));

                    ビルNo++;
                }
            }

            // B -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    this.ビル[ビルNo].Initialize(graphics, true, 16, 32, 16, 32, 1, ビルNo + 1); // 方形

                    this.ビル[ビルNo].pos = new Vector3(0, 球半径 - 1, 0); // ppp
                    this.ビル[ビルNo].単位行列 = Matrix.Identity;

                    this.ビル[ビルNo].m_外壁テクスチャNo = 2;
                    this.ビル[ビルNo].m_床テクスチャNo = 2;

                    float L = ((float)Math.PI * 球半径) / 2f;  // 球上の移動量 赤道1

                    this.ビル[ビルNo].直進_Q(-96 + (i * 64) + L);
                    this.ビル[ビルNo].横移動_Q(-96 + (j * 64));

                    ビルNo++;
                }
            }

            // C -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    this.ビル[ビルNo].Initialize(graphics, true, 1, 56, 56, 1, 1, ビルNo + 1); // 4面体

                    this.ビル[ビルNo].pos = new Vector3(0, 球半径 - 1, 0); // ppp
                    this.ビル[ビルNo].単位行列 = Matrix.Identity;

                    this.ビル[ビルNo].m_外壁テクスチャNo = 3;
                    this.ビル[ビルNo].m_床テクスチャNo = 3;


                    float L = ((float)Math.PI * 球半径);  // 球上の移動量 南極

                    this.ビル[ビルNo].直進_Q(-96 + (i * 64) + L);
                    this.ビル[ビルNo].横移動_Q(-96 + (j * 64));

                    ビルNo++;
                }
            }

            // D -------------------
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    this.ビル[ビルNo].Initialize(graphics, true, 56, 56, 1, 1, 1, ビルNo + 1); // 逆台形

                    this.ビル[ビルNo].pos = new Vector3(0, 球半径 - 1, 0); // ppp
                    this.ビル[ビルNo].単位行列 = Matrix.Identity;

                    this.ビル[ビルNo].m_外壁テクスチャNo = 4;
                    this.ビル[ビルNo].m_床テクスチャNo = 4;

                    float L = ((float)Math.PI * 球半径) / 2f;  // 球上の移動量 赤道2

                    this.ビル[ビルNo].直進_Q(-96 + (i * 64) - L);
                    this.ビル[ビルNo].横移動_Q(-96 + (j * 64));

                    ビルNo++;
                }
            }

            // ビル床設定
            for (int i = 0; i < this.ビル.Length; i++)
            {
                this.bビル表示[i] = false;
                this.ビル[i].床pos設定();   // 床のposと単位行列を再設定( 順序注意 ビルのposと行列設定後に設定 )
            }

            // ビルが重なっていないことを確認する。
        }
        

        
        
        
        
        
        
        
        
        
        
        
        
        
        // --------------------------------------
        // 通常表示
        public void Draw(   GraphicsDeviceManager graphics,

                            BasicEffect effect,         // ライティング+テクスチャ
                            Effect      effect_simple,  // 等高線表示用 ライティング無し

                            Matrix view,
                            Matrix proj,
                            
                            Vector3 カメラ座標,
                            int レイチェックビルNo
                        )
        {

            // ------------------------------------------------------
            // !! カメラからの距離が近い物を詳細表示
            ArrayList exAL内 = new ArrayList(); // すい台内のビル
            ArrayList exAL外 = new ArrayList(); // すい台外のビル

            Vector3 len;

            for (int i = 0; i < this.ビル.Length; i++)
            {
                if ( i == レイチェックビルNo) 
                {
                    continue;
                }

                if ( this.bビル表示[i] )
                {
                    // すい台内
                    len = this.ビル[i].pos - カメラ座標;
                    this.ビル[i].length = len.Length();
                    exAL内.Add(this.ビル[i]);	// ArrayListに追加
                }
                else
                {
                    // すい台外
                    exAL外.Add(this.ビル[i]);	// ArrayListに追加
                }
            }

            // すい台外表示
            for (int i = 0; i < exAL外.Count; i++)
            {
                ビル exビル = (ビル)exAL外[i];
                exビル.Draw簡略1(graphics, effect, view, proj);
            }

            // すい台内表示
            exAL内.Sort(new SortByLength());	// lengthでソート

            // 遠い物から順に表示
            for (int i = 0; i < exAL内.Count; i++)
            {
                ビル exビル = (ビル)exAL内[i];

                if (i > exAL内.Count - 5)
                {
                    // カメラに近い4つのビルを詳細表示
                    exビル.Draw詳細(graphics, effect, view, proj);
                }
                else
                {
                    exビル.Draw簡略2(graphics, effect, effect_simple, view, proj);
                }
            }


            if (-1 != レイチェックビルNo)
            {
                // レイが当たっているビルNo. : 詳細表示をする。
                this.ビル[レイチェックビルNo].Draw詳細(graphics, effect, view, proj);
            }

        }
        // --------------------------------------















/*
        // --------------------------------------
        // 選択されたビルが有る場合、詳細表示
        public void Draw(   GraphicsDeviceManager graphics,

                            BasicEffect effect,         // ライティング+テクスチャ
                            Effect effect_simple,  // 等高線表示用 ライティング無し

                            Matrix view,
                            Matrix proj,

                            Vector3 カメラ座標,
                            
                            int i選択ビル   // ピックされたビルの配列番号
                        )
        {
            for (int i = 0; i < this.Cube.Length; i++)
            {
                this.Cube[i].Draw(graphics, effect, effect_simple, view, proj);
            }

            // 編集対象のビルが選択
            // ビルが編集中の場合、編集中のビルのみ詳細表示、それ以外は簡略表示2
            for (int i = 0; i < this.ビル.Length; i++)
            {
                if (i選択ビル != i)
                {
                    this.ビル[i].Draw簡略2(graphics, effect, effect_simple, view, proj);
                }
            }

            // 選択されたビルを詳細表示+バウンディングボックスを表示
            this.ビル[i選択ビル].Draw詳細(graphics, effect, view, proj);
            this.ビル[i選択ビル].DrawBoundingBox(graphics, effect, view, proj);

        } // Draw
        // --------------------------------------
*/


        // --------------------------------------
        // 選択されたビルのみ、詳細表示 (使用せず)
        public void Drawビル編集(   GraphicsDeviceManager graphics,

                            BasicEffect effect,         // ライティング+テクスチャ
                            Effect effect_simple,  // 等高線表示用 ライティング無し

                            Matrix view,
                            Matrix proj,

                            int i選択ビル   // ピックされたビルの配列番号
                        )
        {

            // ------------------------------------------------------
            ArrayList exAL内 = new ArrayList(); // すい台内のビル
            ArrayList exAL外 = new ArrayList(); // すい台外のビル

            for (int i = 0; i < this.ビル.Length; i++)
            {
                if (i == i選択ビル)
                {
                    // 選択ビルはArrayListに格納しない。
                    continue;
                }

                if (this.bビル表示[i])
                {
                    // すい台内
                    exAL内.Add(this.ビル[i]);	// ArrayListに追加
                }
                else
                {
                    // すい台外
                    exAL外.Add(this.ビル[i]);	// ArrayListに追加
                }
            }

            // すい台外表示
            for (int i = 0; i < exAL外.Count; i++)
            {
                ビル exビル = (ビル)exAL外[i];
                exビル.Draw簡略1(graphics, effect, view, proj);
            }

            // すい台内表示
            for (int i = 0; i < exAL内.Count; i++)
            {
                ビル exビル = (ビル)exAL内[i];
                exビル.Draw簡略2(graphics, effect, effect_simple, view, proj);
            }
            
            // 選択されたビルを詳細表示+バウンディングボックスを表示
            this.ビル[i選択ビル].Draw詳細(graphics, effect, view, proj);
            this.ビル[i選択ビル].DrawBoundingBox(graphics, effect, view, proj);

        } // Drawビル編集
        // --------------------------------------





        // --------------------------------------
        // 選択されたビルのみ、詳細表示
        public void Drawビル編集2(GraphicsDeviceManager graphics,

                            BasicEffect effect,     // ライティング+テクスチャ

                            Effect effect_simple,   // 等高線表示用 ライティング無し
                            Effect  EEEeffect2,     // 線球用 陰線の色を落とす

                            Matrix view,
                            Matrix proj,

                            int i選択ビル,          // ピックされたビルの配列番号
                            bool b非選択ビル線表示  // true:線表示 / flase:面表示
                        )
        {

            // ------------------------------------------------------
            for (int i = 0; i < this.ビル.Length; i++)
            {
                if (i == i選択ビル)
                {
                    // 選択ビルは詳細表示する。
                    continue;
                }

                if (b非選択ビル線表示)// true:線表示 / flase:面表示
                {
                    this.ビル[i].Drawライン(graphics, EEEeffect2, view, proj);  // 線表示
                }
                else
                {
                    this.ビル[i].Draw簡略1(graphics, effect, view, proj);     // 面表示
                }
            }

            // 選択されたビルを詳細表示+バウンディングボックスを表示
            this.ビル[i選択ビル].Draw詳細(graphics, effect, view, proj);
            this.ビル[i選択ビル].DrawBoundingBox(graphics, effect, view, proj);

        } // Drawビル編集2
        // --------------------------------------
















    } // class 地形






    // ===========================================================================
    /// <summary>
    /// ビルを視点との距離でソート 
    /// </summary>
    public class SortByLength : IComparer
    {
        public SortByLength()
        {
        }

        public int Compare(object x, object y)
        {
            // TODO:  SortByF.Compare 実装を追加します。
            ビル tmp_x = (ビル)x;
            ビル tmp_y = (ビル)y;

            // < を逆にすると逆順でソート
            if (tmp_x.length < tmp_y.length)
                return 1;
            if (tmp_x.length > tmp_y.length)
                return -1;
            else
                return 0;
        }
    }








}





